/****************************************************************************
 * This file is part of the project AqHome.
 * AqHome (c) by 2023 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "aqhome/msg/msg_value2.h"

#include <gwenhywfar/misc.h>
#include <gwenhywfar/list.h>
#include <gwenhywfar/error.h>
#include <gwenhywfar/debug.h>



#define AQH_MSG_OFFS_VALUE2_UID         0
#define AQH_MSG_OFFS_VALUE2_VALUEID     4
#define AQH_MSG_OFFS_VALUE2_VALUETYPE   5
#define AQH_MSG_OFFS_VALUE2_VALUE       6
#define AQH_MSG_OFFS_VALUE2_DENOM       8

#define AQH_MSG_VALUE2_MINSIZE          (AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE2_DENOM+2)




uint32_t AQH_Value2Msg_GetUid(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint32At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE2_UID, 0);
}



uint8_t AQH_Value2Msg_GetValueId(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint8At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE2_VALUEID, 0);
}



uint8_t AQH_Value2Msg_GetValueType(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint8At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE2_VALUETYPE, 0);
}



int16_t AQH_Value2Msg_GetValueNom(const GWEN_MSG *msg)
{
  return (int16_t) GWEN_Msg_GetUint16At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE2_VALUE, 0);
}



int16_t AQH_Value2Msg_GetValueDenom(const GWEN_MSG *msg)
{
  return (int16_t) GWEN_Msg_GetUint16At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE2_DENOM, 0);
}



const char *AQH_Value2Msg_GetValueTypeName(const GWEN_MSG *msg)
{
  uint8_t t;

  t=AQH_Value2Msg_GetValueType(msg);
  switch(t) {
  case AQH_MSG_VALUE2_TYPE_TEMP:     return "temperature";
  case AQH_MSG_VALUE2_TYPE_HUMIDITY: return "humidity";
  case AQH_MSG_VALUE2_TYPE_DOOR:     return "door_window";
  default:                           break;
  }
  return "unknown";
}



const char *AQH_Value2Msg_GetValueAsWindowStateString(const GWEN_MSG *msg)
{
  switch(AQH_Value2Msg_GetValueNom(msg)) {
  case 0:   return "closed";
  case 128: return "tilted";
  case 255: return "open";
  default:  break;
  }
  return "unknown";
}



const char *AQH_Value2Msg_GetValueTypeUnits(const GWEN_MSG *msg)
{
  uint8_t t;

  t=AQH_Value2Msg_GetValueType(msg);
  switch(t) {
  case AQH_MSG_VALUE2_TYPE_TEMP:     return "Celsius";
  case AQH_MSG_VALUE2_TYPE_HUMIDITY: return "%";
  case AQH_MSG_VALUE2_TYPE_DOOR:     return NULL;
  default:                           break;
  }
  return NULL;
}



double AQH_Value2Msg_GetValue(const GWEN_MSG *msg)
{
  if ((AQH_NodeMsg_GetMsgType(msg)==AQH_MSG_TYPE_VALUE2) &&
      (GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_VALUE2_MINSIZE)) {
    const uint8_t *ptr;
    double value;
    double denom;
    uint16_t intDenom;

    ptr=GWEN_Msg_GetConstBuffer(msg)+AQH_MSG_OFFS_ALL_DATA_BEGIN;
    value=(double)((ptr[AQH_MSG_OFFS_VALUE2_VALUE])+(ptr[AQH_MSG_OFFS_VALUE2_VALUE+1]<<8));
    intDenom=(ptr[AQH_MSG_OFFS_VALUE2_DENOM])+(ptr[AQH_MSG_OFFS_VALUE2_DENOM+1]<<8);
    denom=(double)(intDenom);
    if (intDenom==0)
      denom=1.0;
    return (double)(value/denom);

  }
  return 0.0;
}



void AQH_Value2Msg_DumpToBuffer(const GWEN_MSG *msg, GWEN_BUFFER *dbuf, const char *sText)
{
  if ((AQH_NodeMsg_GetMsgType(msg)==AQH_MSG_TYPE_VALUE2) &&
      (GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_VALUE2_MINSIZE)) {
      if (AQH_Value2Msg_GetValueType(msg)==AQH_MSG_VALUE2_TYPE_DOOR)
	GWEN_Buffer_AppendArgs(dbuf, "0x%02x->0x%02x: VALUE2 %s (uid=0x%08x, value_id=0x%02x type=%s value=%s)\n",
			       AQH_NodeMsg_GetSourceAddress(msg),
			       AQH_NodeMsg_GetDestAddress(msg),
			       sText,
			       (unsigned int) AQH_Value2Msg_GetUid(msg),
			       AQH_Value2Msg_GetValueId(msg),
			       AQH_Value2Msg_GetValueTypeName(msg),
			       AQH_Value2Msg_GetValueAsWindowStateString(msg));
      else
	GWEN_Buffer_AppendArgs(dbuf, "0x%02x->0x%02x: VALUE2 %s (uid=0x%08x, value_id=0x%02x type=%s value=%f)\n",
			       AQH_NodeMsg_GetSourceAddress(msg),
			       AQH_NodeMsg_GetDestAddress(msg),
			       sText,
			       (unsigned int) AQH_Value2Msg_GetUid(msg),
			       AQH_Value2Msg_GetValueId(msg),
			       AQH_Value2Msg_GetValueTypeName(msg),
			       AQH_Value2Msg_GetValue(msg));
  }
}




